<%@ Page Language="VB" Debug="False" Strict="True" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.OleDB" %>

<script language="VB" runat="server">
Sub Page_Load(sender As Object, e As EventArgs)
  If Not IsPostBack Then
    TextBox1.Text = "PROVIDER=SQLOLEDB; Data Source=localhost; Initial Catalog=database;User ID=sa;Password=;"
    Label1.Text = ""
  End If
End Sub

'Connect to database and get list of tables, catch any OleDbException
Sub Button1_Click(sender As Object, e As EventArgs)
  Dim dc As OleDbConnection = New OleDbConnection(TextBox1.Text)
  Label1.Text = ""
  Try
    dc.Open()
    'List the table name from each row in the schema table
    Dim tbdt As DataTable = dc.GetOleDbSchemaTable(OleDbSchemaGuid.Tables, _
        New Object() {Nothing, Nothing, Nothing, "TABLE"})
    Dim atables As ArrayList= new ArrayList()
    Dim i As Integer
    For i = 0 To tbdt.Rows.Count - 1
      atables.Add(tbdt.Rows(i)!TABLE_NAME.ToString)
    Next i
    DropDownList1.DataSource = atables
    DropDownList1.DataBind
    dc.Close()
  Catch ox As OleDbException
    Label1.Text = ox.Message
  End Try

  Panel1.Visible= False
  Panel2.Visible = False

End Sub

'Bind specified table column schema to datagrid and make visible
'Get first primary key, catch any OleDbException
Sub Button3_Click(sender As Object, e As EventArgs)
  Dim dc As OleDbConnection = New OleDbConnection(TextBox1.Text)
  Dim pkdt As DataTable
  Label1.Text = ""
  Try
    dc.Open()
    'Get Schema information for the specified table
    Dim dt As DataTable = dc.GetOleDbSchemaTable(OleDbSchemaGuid.Columns, _
        New Object() {Nothing, Nothing, DropDownList1.SelectedItem.Text})
    pkdt = dc.GetOleDbSchemaTable(OleDbSchemaGuid.Primary_Keys, _
        New Object() {Nothing, Nothing, DropDownList1.SelectedItem.Text})
    dg.DataSource = dt
    dg.DataBind()
    dc.Close()
    Panel1.Visible= True
  Catch ox As OleDbException
    Label1.Text = ox.Message
  End Try

  If Label1.Text = "" Then
    Try
      Label2.Text = pkdt.Rows(0).Item(3).ToString
    Catch x As Exception
      Label1.Text = "A single primary key is required in the database table."
      Panel1.Visible= False
    End Try
  End If

  Panel2.Visible = False

End Sub

'Build new web page, place it in textbox, and make it visible
Sub Button2_Click(sender As Object, e As EventArgs)

  Dim i As Integer
  Dim ii As Integer
  Dim iii As Integer
  Dim iiii As Integer
  Dim iMDB As Integer = InStr(1, TextBox1.Text.ToUpper(), ".MDB") 
  Dim di As DataGridItem
  Dim di2 As DataGridItem
  Dim di3 As DataGridItem
  Dim di4 As DataGridItem
  Dim dr As DataRow
  Dim sb as StringBuilder = New StringBuilder()
  Dim s as String
  Dim b1 As Boolean = True
  Dim bQuote As Boolean = True
  sb.Append("<%@ Page Language=""VB"" Debug=""False"" %>" & vblf)
  sb.Append("<%@ Import Namespace=""System.Data"" %>" & vblf)
  sb.Append("<%@ Import Namespace=""System.Data.OleDb"" %>" & vblf & vblf)
  sb.Append("<script runat=""server"">" & vblf & vblf)
  sb.Append("Protected cs As String = """ & TextBox1.Text & """" & vblf)
  sb.Append("Protected ss As String = ""SELECT * from [" & DropDownList1.SelectedItem.Text & "]""" & vblf)
  sb.Append("Dim bEditing As Boolean = False" & vblf)
  sb.Append("Sub Page_Load(Sender As Object, E As EventArgs)" & vblf & vblf)
  sb.Append("  If Not Page.IsPostBack Then" & vblf)
  sb.Append("    Label1.Text = ""ASC""" & vblf)
  sb.Append("    BindGrid()" & vblf)
  sb.Append("  End If" & vblf)
  sb.Append("End Sub" & vblf & vblf)
  sb.Append("Sub BindGrid()" & vblf)
  sb.Append("  Dim dc As New OleDbConnection(cs)" & vblf)
  sb.Append("  Dim da As New OleDbDataAdapter(ss, dc)" & vblf)
  sb.Append("  Dim ds As New DataSet()" & vblf)
  sb.Append("  da.Fill(ds)" & vblf)
  sb.Append("  da.Fill(ds,""" & DropDownList1.SelectedItem.Text & """)" & vblf)
  sb.Append("  Dim dv As DataView = ds.Tables(""" & DropDownList1.SelectedItem.Text & """).DefaultView" & vblf)
  sb.Append("  If Label2.Text <> """" Then dv.Sort = Label2.Text + "" "" + Label1.Text" & vblf)
  sb.Append("  dg.DataSource = dv" & vblf)
  sb.Append("  dg.DataBind()" & vblf)
  sb.Append("End Sub" & vblf & vblf)
  sb.Append("Sub dg_Page(Sender As Object, E As DataGridPageChangedEventArgs)" & vblf)
  sb.Append("  If Not bEditing Then" & vblf)
  sb.Append("    dg.CurrentPageIndex = e.NewPageIndex" & vblf)
  sb.Append("    BindGrid()" & vblf)
  sb.Append("  End If" & vblf)
  sb.Append("End Sub" & vblf & vblf)
  sb.Append("Sub dg_Sort(Sender As Object, E As DataGridSortCommandEventArgs)" & vblf)
  sb.Append("  If Not bEditing Then" & vblf)
  sb.Append("    If Label2.Text = e.SortExpression Then" & vblf)
  sb.Append("      If Label1.Text = ""ASC"" Then" & vblf)
  sb.Append("        Label1.Text = ""DESC""" & vblf)
  sb.Append("      Else" & vblf)
  sb.Append("        Label1.Text = ""ASC""" & vblf)
  sb.Append("      End If" & vblf)
  sb.Append("    End If" & vblf)
  sb.Append("    Label2.Text = e.SortExpression" & vblf)
  sb.Append("    BindGrid()" & vblf)
  sb.Append("  End If" & vblf)
  sb.Append("End Sub" & vblf & vblf)

  'If Allow Edit? is checked create edit, cancel, and update routines
  If CheckBox1.Checked Then
    sb.Append("Sub dg_Edit(sender As Object, e As DataGridCommandEventArgs)" & vblf)
    sb.Append("  If Not bEditing Then" & vblf)
    sb.Append("    dg.EditItemIndex = e.Item.ItemIndex" & vblf)  
    sb.Append("    BindGrid()" & vblf)
    sb.Append("    SingleColumn(False)" & vblf)
    sb.Append("  End If" & vblf)
    sb.Append("End Sub" & vblf & vblf)
    sb.Append("Sub dg_Cancel(sender As Object, e As DataGridCommandEventArgs)" & vblf)
    sb.Append("  dg.EditItemIndex = - 1" & vblf)  
    sb.Append("  BindGrid()" & vblf)
    sb.Append("  SingleColumn(True)" & vblf)
    sb.Append("End Sub" & vblf & vblf)
    sb.Append("Sub dg_Update(sender As Object, e As DataGridCommandEventArgs)" & vblf)
    sb.Append("  dg.EditItemIndex = - 1" & vblf)  
    sb.Append("  Dim strcmd As String = ""UPDATE " & DropDownList1.SelectedItem.Text & " SET """ & vblf)
    sb.Append("  Dim pkvalue As String = dg.DataKeys(CInt(E.Item.ItemIndex))" & vblf)
    For iii = 1 To dg.Items.Count
      di3 = dg.Items(iii - 1)
      Dim NameString3 as String =  di3.Cells(0).Text
      Dim EditCheckBox2 as CheckBox = Ctype(di3.FindControl("cbEdit"),CheckBox)
      If NameString3 <> Label2.Text Then
        If EditCheckBox2.Checked then
        sb.Append("  Dim field" & iii & " As String = CType(e.Item.FindControl(""Field" & iii & """), TextBox).Text" & vblf)
        Select Case CInt(di3.Cells(1).Text)
          Case 2, 3, 4, 5, 6, 17, 20, 131
            sb.Append("  strcmd = strcmd & """ & NameString3 & " = """ & " & field" & iii & " & "" , """ & vblf)
            bQuote = False 
         Case 7, 135
            If imdb > 0 Then
              sb.Append("  strcmd = strcmd & """ & NameString3 & " = #""" & " & field" & iii & " & ""# , """ & vblf)
            Else
              sb.Append("  strcmd = strcmd & """ & NameString3 & " = '""" & " & field" & iii & " & ""' , """ & vblf)
            End If
            bQuote = True 
          Case 11
            sb.Append("  If field" & iii & " = ""True"" Then" & vblf)
            sb.Append("    field" & iii & " = ""1""" & vblf)
            sb.Append("  Else" & vblf)
            sb.Append("    field" & iii & " = ""0""" & vblf)
            sb.Append("  End If" & vblf)
            sb.Append("  strcmd = strcmd & """ & NameString3 & " = """ & " & field" & iii & " & "" , """ & vblf)
            bQuote = True 
          Case Else
            sb.Append("  strcmd = strcmd & """ & NameString3 & " = '""" & " & field" & iii & " & ""' , """ & vblf)
            bQuote = True 
        End Select
        End If
      End If
    next
    If bQuote = True Then
      sb.Length = sb.Length - 5
      sb.Append("""")
    Else
      sb.Length = sb.Length - 8
    End If
    sb.Append(vblf &  "  strcmd = strcmd  & "" WHERE " & Label2.Text & " = """ & " & pkvalue" &  vblf)
    sb.Append("  Dim dc As New OleDbConnection(cs)" & vblf)
    sb.Append("  Dim cmd As New OleDbCommand(strcmd, dc)" & vblf)
    sb.Append("  Try" & vblf)
    sb.Append("    dc.Open()" & vblf)
    sb.Append("    cmd.ExecuteNonQuery()" & vblf)
    sb.Append("  Catch ex as OleDbException" & vblf)
    sb.Append("    Label3.Text = ex.ToString()" & vblf)
    sb.Append("  Finally" & vblf)
    sb.Append("    dc.Close()" & vblf)
    sb.Append("  End Try" & vblf)
    sb.Append("  BindGrid()" & vblf)
    sb.Append("  SingleColumn(True)" & vblf)
    sb.Append("End Sub" & vblf & vblf)
  End If

  'If Allow Delete? is checked create delete and item created (to confirm delete) routines
  If CheckBox2.Checked Then
    sb.Append("Sub dg_Delete(Sender As Object, E As DataGridCommandEventArgs)" & vblf)
    sb.Append("  If Not bEditing Then" & vblf)
    sb.Append("    Dim pkvalue As String = dg.DataKeys(CInt(E.Item.ItemIndex))" & vblf)
    sb.Append("    Dim dc As New OleDbConnection(cs)" & vblf)
    sb.Append("    Dim cmd As New OleDbCommand(""DELETE from " & DropDownList1.SelectedItem.Text & _
      " where " & Label2.Text & " = "" & pkvalue , dc)" & vblf)
    sb.Append("    dc.Open()" & vblf)
    sb.Append("    cmd.ExecuteNonQuery()" & vblf)
    sb.Append("    dc.Close()" & vblf)
    sb.Append("    dg.CurrentPageIndex = 0" & vblf)
    sb.Append("    dg.EditItemIndex = - 1" & vblf)
    sb.Append("    BindGrid()" & vblf)
    sb.Append("  End If" & vblf)
    sb.Append("End Sub" & vblf & vblf)
    sb.Append("Sub dg_ItemCreated(ByVal sender As Object, ByVal e As DataGridItemEventArgs)" & vblf)
    sb.Append("  If (e.Item.ItemType = ListItemType.Item Or e.Item.ItemType = ListItemType.AlternatingItem) Then" _
      & vblf)
    sb.Append("    Dim deletebutton As WebControl = CType(e.Item.Cells(dg.Columns.Count - 1).Controls(0), WebControl)" _
      & vblf)
    sb.Append("    deletebutton.Attributes.Add(""onclick"", _" & vblf)
    sb.Append("        ""return confirm('Are you sure you want to delete this record?');"")" & vblf)
    sb.Append("  End If" & vblf)
    sb.Append("End Sub" & vblf & vblf)
  End If

  'If Allow Add? is checked create add routine
  If CheckBox1.Checked And CheckBox3.Checked Then
    sb.Append("Sub dg_Add(Sender As Object, E As EventArgs)" & vblf)
    sb.Append("    CheckEditing("""")" & vblf)
    sb.Append("  If Not bEditing Then" & vblf)
    sb.Append("    Dim dc As New OleDbConnection(cs)" & vblf)
    sb.Append("    Dim cmd As New OleDbCommand(""INSERT into " & DropDownList1.SelectedItem.Text & "(")

    Dim CommandString1 As String = ""
    Dim CommandString2 As String = ""
    For iiii = 1 To dg.Items.Count
      di4 = dg.Items(iiii - 1)
      Dim NameString4 as String =  di4.Cells(0).Text
      If NameString4 <> Label2.Text Then
        CommandString1 = CommandString1 & NameString4 & ","
        Select Case CInt(di4.Cells(1).Text)
          Case 2, 3, 4, 5, 6, 17, 20, 131
             CommandString2 = CommandString2 & "0,"
         Case 7, 135
            If imdb > 0 Then
              CommandString2 = CommandString2 & "#1/1#,"
            Else
              CommandString2 = CommandString2 & "'',"
            End If
            bQuote = True 
          Case 11
            CommandString2 = CommandString2 & "1," 
          Case Else
            CommandString2 = CommandString2 & "'',"
        End Select
      End If
    next
    CommandString1 = Left(CommandString1, Len(CommandString1) - 1)
    CommandString2 = Left(CommandString2, Len(CommandString2) - 1)
    sb.Append(CommandString1 & ") Values (" & CommandString2 & ")"", dc)" & vblf)
    sb.Append("    dc.Open()" & vblf)
    sb.Append("    cmd.ExecuteNonQuery()" & vblf)
    sb.Append("    dc.Close()" & vblf)
    sb.Append("    dg.CurrentPageIndex = dg.PageCount - 1" & vblf)
    sb.Append("    BindGrid()" & vblf)
    sb.Append("    SingleColumn(False)" & vblf)
    sb.Append("    dg.EditItemIndex = dg.Items.Count - 1" & vblf)
    sb.Append("    BindGrid()" & vblf)
    sb.Append("  End If" & vblf)
    sb.Append("End Sub" & vblf & vblf)
  End If

  'Hides all columns except one when editing a record
  sb.Append("Sub SingleColumn(b As Boolean)" & vblf)
  sb.Append("  Dim i As Integer" & vblf)
  sb.Append("  For  i = 2 To  dg.Columns.Count - 1" & vblf)
  sb.Append("    dg.Columns(i).Visible = b" & vblf)
  sb.Append("  Next" & vblf)
  sb.Append("  Label3.Text = """"" & vblf)
  sb.Append("End Sub" & vblf & vblf)
  sb.Append("Sub dg_Item(Sender As Object, E As DataGridCommandEventArgs)" & vblf)
  sb.Append("  CheckEditing(e.CommandName)" & vblf)
  sb.Append("End Sub" & vblf & vblf)
  sb.Append("Sub CheckEditing(commandName As String)" & vblf)
  sb.Append("  If dg.EditItemIndex <> -1 Then" & vblf)
  sb.Append("    If commandName <> ""Cancel"" And commandName <> ""Update"" Then" & vblf)
  sb.Append("     Label3.Text = ""Please click update to save your changes, or cancel ")
  sb.Append("to discard your changes, before selecting another item.""" & vblf)
  sb.Append("      bEditing = True" & vblf)
  sb.Append("    End If" & vblf)
  sb.Append("  End If" & vblf)
  sb.Append("End Sub" & vblf & vblf)


  sb.Append("</" & "script>"  & vblf & vblf)
  sb.Append("<html>" & vblf)
  sb.Append("<head>" & vblf)
  sb.Append("<title>" & DropDownList1.SelectedItem.Text.ToUpper() & "</title>" & vblf)
  sb.Append("</head>" & vblf)
  sb.Append("<body style=""font-family: arial"">" & vblf)
  sb.Append("<h1>" & DropDownList1.SelectedItem.Text.ToUpper() & "</h1>" & vblf)
  sb.Append("<hr size=""1"" />" & vblf)
  sb.Append("<form runat=""server"">" & vblf)
  sb.Append("<asp:datagrid id=""dg"" runat=""server"" width=""80%""" & vblf)
  sb.Append("  CellSpacing=""1""" & vblf)
  sb.Append("  GridLines=""None""" & vblf)
  sb.Append("  CellPadding=""3""" & vblf)
  sb.Append("  BackColor=""White""" & vblf)
  sb.Append("  ForeColor=""Black""" & vblf)
  sb.Append("  OnPageIndexChanged=""dg_Page""" & vblf)
  sb.Append("  PageSize=""10""" & vblf)
  sb.Append("  AllowPaging=""True""" & vblf)
  sb.Append("  Font-Size=""X-Small""" & vblf)
  sb.Append("  AutoGenerateColumns=""False""" & vblf)
  sb.Append("  AllowSorting=""True""" & vblf)
  sb.Append("  Font-Names=""Verdana""" & vblf)
  sb.Append("  DataKeyField=""" & Label2.Text & """" & vblf)
 
  'If Allow Delete? checked 
  If CheckBox2.Checked Then
    sb.Append("  OnDeleteCommand=""dg_Delete""" & vblf)
    sb.Append("  OnItemCreated=""dg_ItemCreated""" & vblf)
  End If

  'If Allow Edit? checked
  If CheckBox1.Checked Then
    sb.Append("  OnEditCommand=""dg_Edit""" & vblf)
    sb.Append("  OnCancelCommand=""dg_Cancel""" & vblf)
    sb.Append("  OnUpdateCommand=""dg_Update""" & vblf)
  End If

  sb.Append("  OnItemCommand=""dg_Item""" & vblf)
  sb.Append("  OnSortCommand=""dg_Sort"">" & vblf)
  sb.Append("<FooterStyle backcolor=""#C6C3C6""></FooterStyle>" & vblf)
  sb.Append("<HeaderStyle font-bold=""True"" forecolor=""White"" backcolor=""#4A3C8C"">" & vblf)
  sb.Append("</HeaderStyle>" & vblf)
  sb.Append("<PagerStyle horizontalalign=""Right"" backcolor=""#C6C3C6"" mode=""NumericPages"">" & vblf)
  sb.Append("</PagerStyle>" & vblf)
  sb.Append("<AlternatingItemStyle backcolor=""LightSteelBlue""></AlternatingItemStyle>" & vblf)
  sb.Append("<ItemStyle backcolor=""#DEDFDE""></ItemStyle>" & vblf)
  sb.Append("<Columns>" & vblf)

  'Create datagrid edit column
  If CheckBox1.Checked Then
    sb.Append("  <asp:EditCommandColumn ButtonType=""LinkButton"" "  & vblf)
    sb.Append("  UpdateText=""Update"" CancelText=""Cancel"" "  & vblf)
    sb.Append("  EditText=""Edit""></asp:EditCommandColumn>" & vblf)
  End If 

  'Create datagrid bound columns
  For i = 0 To dg.Items.Count - 1
    di = dg.Items(i)
    Dim ShowCheckBox as CheckBox = Ctype(di.FindControl("cbShow"),CheckBox)
    Dim SortCheckBox as CheckBox = Ctype(di.FindControl("cbSort"),CheckBox)
    Dim NameString as String =  di.Cells(0).Text
    If ShowCheckBox.Checked then
      If CheckBox1.Checked And b1 = True Then
        sb.Append("  <asp:TemplateColumn HeaderText = """ & NameString.ToUpper() & """")
        If SortCheckBox.Checked then
          sb.Append(" SortExpression=""" & NameString & """")
        End If
        sb.Append(">" & vblf)
        sb.Append("    <ItemTemplate>" & vblf)
        sb.Append("      <%# DataBinder.Eval(Container.DataItem, """ & NameString & """).ToString() %>" & vblf)
        sb.Append("    </ItemTemplate>" & vblf)

        ' Create edit item template in first column if Allow Edit? checked
        sb.Append("    <EditItemTemplate>" & vblf)
        sb.Append("      <Table CellPadding=""5"" CellSpacing=""0"" Border=""1"">" & vblf)
        For ii = 0 To dg.Items.Count - 1
          di2 = dg.Items(ii)
          Dim EditCheckBox as CheckBox = Ctype(di2.FindControl("cbEdit"),CheckBox)
          Dim MultilineCheckBox as CheckBox = Ctype(di2.FindControl("cbMultiline"),CheckBox)
          Dim NameString2 as String =  di2.Cells(0).Text.ToString
          'Dim TypeString as String =  di2.Cells(1).Text.ToString
         'Include in template if edit? for that field is checked
         If EditCheckBox.Checked then
           sb.Append("        <tr><td>" & vblf)
           sb.Append("        <asp:Label Text=""" & NameString2 & """ id=""FieldLabel" & ii + 1 & """ runat=""server"" />" & vblf)
           sb.Append("        </td><td>" & vblf)
           sb.Append("        <asp:TextBox id=""Field" & ii + 1 & """ runat=""Server"" " & vblf) 
           sb.Append("        Text= '<%# DataBinder.Eval(Container.DataItem, """ & NameString2 & """)%>'" & vblf)
           If MultilineCheckBox.Checked then
             sb.Append("        TextMode=""multiline"" ")
           End If
           If NameString2 = Label2.Text Then 
             sb.Append("        enabled=""false"" " )
           End If
           sb.Append("        columns=""60""/>" & vblf)
           sb.Append("        </td></tr>" & vblf)
         End If


        Next
        sb.Append("      </Table>" & vblf)
        sb.Append("    </EditItemTemplate>" & vblf)
        sb.Append("  </asp:TemplateColumn>" & vblf)
        b1 = False
      Else
        sb.Append("  <asp:BoundColumn DataField=""" & NameString & """" )
          If SortCheckBox.Checked then
            sb.Append(" SortExpression=""" & NameString & """" )
          End If
        sb.Append(" HeaderText=""" & NameString.ToUpper() & """>" & vblf)
        sb.Append(" </asp:BoundColumn>" & vblf)
      End if
    End If
  Next

  'Create datagrid delete column
  If CheckBox2.Checked Then
    sb.Append("  <asp:ButtonColumn Text=""Delete"" CommandName=""Delete"" >" & vblf)
    sb.Append("  </asp:ButtonColumn>" & vblf)
  End If 

  sb.Append("</Columns>" & vblf)
  sb.Append("</asp:datagrid>" & vblf & vblf)
  If CheckBox1.Checked And CheckBox3.Checked Then
    sb.Append("<asp:LinkButton id=""LinkButton1"" onclick=""dg_add"" " & vblf)
    sb.Append("runat=""server"" Font-Size=""smaller"" Text=""Add New""> " & vblf)
    sb.Append("</asp:LinkButton>" & vblf)
  End If
  sb.Append("</form>" & vblf & vblf)
  sb.Append("<asp:Label id=""Label1"" runat=""server"" Visible=""False"" />" & vblf)
  sb.Append("<asp:Label id=""Label2"" runat=""server"" Visible=""False"" />" & vblf)
  sb.Append("<asp:Label id=""Label3"" runat=""server"" Visible=""True"" />" & vblf & vblf)
  sb.Append("</body>" & vblf)
  sb.Append("</html>" & vblf)

  'Place code in textbox and make it visible
  s = sb.ToString()
  s = System.Web.HttpUtility.HTMLEncode(s)
  TextArea1.Value = s
  Panel2.Visible=True
End Sub

</script>

<html>
<head>
<title>DataGrid Programming Made Easy</title>
</head>
<body bgcolor="#FFFFFF" >
<center>
<font face="Helvetica">
<h3>DataGrid Programming Made Easy</h3>
<Form runat="server" id="Form1">
OleDb Connection String:
<br>
<asp:TextBox id="TextBox1" runat="server" Width="600" />
<br>
<asp:Button id="Button1" Text="Connect" onclick="Button1_Click"
runat="server" />
<br>
<hr size="1" />
<br>
Select a Table:  &nbsp;
<asp:DropDownList id="DropDownList1" runat="server" />
<asp:Button id="Button3" Text="Get Table Info" onclick="Button3_Click"
runat="server" />
<br>
<asp:Label id="Label1" runat="server" Font-Bold="True"
ForeColor="Red"></asp:Label>
<asp:Label id="Label2" runat="server" Visible="False"></asp:Label>
<asp:Panel id="Panel1" runat="server" visible="false">
<br>
<hr size="1" />
<br>
Select DataGrid Column Settings:
<br>
Allow Edit? <asp:CheckBox id="CheckBox1" runat="server" />
Allow Delete? <asp:CheckBox id="CheckBox2" runat="server" />
Allow Add? <asp:CheckBox id="CheckBox3" runat="server" />

<asp:DataGrid id="dg" runat="server"
  CellSpacing="1"
  GridLines="None"
  BorderWidth="3"
  CellPadding="3"
  BackColor="White"
  ForeColor="Black"
  Font-Name="Helvetica"
  Font-Size="X-Small"
  AutoGenerateColumns="False" >
<FooterStyle backcolor="#C6C3C6"></FooterStyle>
<HeaderStyle font-bold="True" forecolor="White"
backcolor="#4A3C8C"></HeaderStyle>
<AlternatingItemStyle 
backcolor="LightSteelBlue"></AlternatingItemStyle>
<ItemStyle backcolor="#DEDFDE"></ItemStyle>
<Columns>
  <asp:BoundColumn HeaderText="Column Name" DataField="Column_Name"/>
  <asp:BoundColumn HeaderText="Data Type" DataField="Data_Type"/>
  <asp:TemplateColumn HeaderText="Show?">
    <ItemTemplate>
      <center>
      <asp:CheckBox id=cbShow runat="server" />
      </center>
    </Itemtemplate>
  </asp:TemplateColumn>
  <asp:TemplateColumn HeaderText="Sort?">
    <ItemTemplate>
      <center>
      <asp:CheckBox id=cbSort runat="server" />
      </center>
    </Itemtemplate>
  </asp:TemplateColumn>
  <asp:TemplateColumn HeaderText="Edit?">
    <ItemTemplate>
      <center>
      <asp:CheckBox id=cbEdit runat="server" />
      </center>
    </Itemtemplate>
  </asp:TemplateColumn>
  <asp:TemplateColumn HeaderText="Multiline?">
    <ItemTemplate>
      <center>
      <asp:CheckBox id=cbMultiline runat="server" />
      </center>
    </Itemtemplate>
  </asp:TemplateColumn>


</Columns>
</asp:datagrid>

<asp:Button id="Button2" Text="Create ASP.NET Page" 
OnClick="Button2_Click"
runat="server" />
</asp:Panel>

<asp:Panel id="Panel2" visible="false" runat="server">
<hr size="1" />
Copy and Save the new ASP.NET Page:<br>
<TextArea id="TextArea1" cols=80 rows=30 runat="server" />
</asp:Panel>

</form>
</font>
</center>
</body>
</html>

